<cms:capture into='markers_data'>
    <cms:folders masterpage='contact-us.php' orderby='count' order='desc'  hierarchical = '1' paginate = '1' limit='1000' >

    '<cms:show k_folder_title />': [
    <cms:pages masterpage='contact-us.php' folder=k_folder_name orderby='page_title' order='asc' >
    {
        name: '<cms:show country />',
        location_latitude: <cms:show lat />,
        location_longitude: <cms:show lng />,
        map_image_url: '<cms:if office_img ><cms:show office_img /><cms:else />img/thumb_map_1.jpg</cms:if>',
        name_point: '<cms:show k_page_title />',
        description_point: '<cms:show address />',
        get_directions_start_address: '',
        phone: [<cms:if tel_1 >'<cms:show tel_1 />'</cms:if><cms:if tel_2>, '<cms:show tel_2 />'</cms:if>],
        url_point: '#position'
    }<cms:if k_paginated_bottom = '0'>,</cms:if>

    </cms:pages>
    ]<cms:if k_paginated_bottom = '0'>,</cms:if>

    </cms:folders>
</cms:capture>

<cms:capture into='offices_selection'>
    <cms:folders masterpage='contact-us.php' orderby='count' order='desc' >
        case '<cms:show k_folder_title />':
        $('#<cms:show k_folder_name/>_offices').show();
        break
    </cms:folders>
        case undefined:
        break
</cms:capture>


(function(A) {
    if (!Array.prototype.forEach)
        A.forEach = A.forEach || function(action, that) {
            for (var i = 0, l = this.length; i < l; i++)
                if (i in this)
                    action.call(that, this[i], i, this);
            };

        })(Array.prototype);

        var
        mapObject,
        markers = [],
        markersData = {

        <cms:show markers_data />

        };

            /* Get map centered by dynamic locations */
            var coordinates = [];
            var bound = new google.maps.LatLngBounds();

            for (var key in markersData){
                markersData[key].forEach(function (item) {
                    coordinates.push([item.location_latitude, item.location_longitude]);
                });
            }

            for (i = 0; i < coordinates.length; i++) {
              bound.extend( new google.maps.LatLng(coordinates[i][0], coordinates[i][1]) );
            }

            var newCenter = bound.getCenter();
            var realCenter = GetCenterFromDegrees(coordinates); //not used

            var mapOptions = {
                zoom: 13,
                // center: new google.maps.LatLng(48.865633, 2.321236),
                center: new google.maps.LatLng(newCenter.lat(), newCenter.lng()),
                mapTypeId: google.maps.MapTypeId.ROADMAP,

                mapTypeControl: false,
                mapTypeControlOptions: {
                    style: google.maps.MapTypeControlStyle.DROPDOWN_MENU,
                    position: google.maps.ControlPosition.LEFT_TOP
                },
                panControl: false,
                panControlOptions: {
                    position: google.maps.ControlPosition.TOP_RIGHT
                },
                zoomControl: true,
                zoomControlOptions: {
                    style: google.maps.ZoomControlStyle.LARGE,
                    position: google.maps.ControlPosition.LEFT_TOP
                },
                 scrollwheel: false,
                scaleControl: false,
                scaleControlOptions: {
                    position: google.maps.ControlPosition.LEFT_TOP
                },
                streetViewControl: true,
                streetViewControlOptions: {
                    position: google.maps.ControlPosition.LEFT_TOP
                },
                styles:

                <cms:get_custom_field 'map_styling' masterpage='js/map.js.php' />

            };
            var
            marker;
            mapObject = new google.maps.Map(document.getElementById('map_contact'), mapOptions);

            /* Make Map fit all Markers */
            mapObject.fitBounds(bound);
            mapObject.panBy(0,0);       // Fix for Maps API, that prevents markers from showing after animation (happens, when next marker to go to is very close)
            showAddresses();

            for (var key in markersData)
                markersData[key].forEach(function (item) {
                    marker = new google.maps.Marker({
                        position: new google.maps.LatLng(item.location_latitude, item.location_longitude),
                        map: mapObject,
                        // icon: 'img/pins/' + key + '.png',
                        icon: 'img/pins/' + 'Walking' + '.png',
                    });

                    if ('undefined' === typeof markers[key])
                        markers[key] = [];
                    markers[key].push(marker);
                    google.maps.event.addListener(marker, 'click', (function () {
                      closeInfoBox();
                      getInfoBox(item).open(mapObject, this);
                      mapObject.setCenter(new google.maps.LatLng(item.location_latitude, item.location_longitude));
                    }));


                });


        function hideAllMarkers () {
            for (var key in markers)
                markers[key].forEach(function (marker) {
                    marker.setMap(null);
                });
        };


        function showAddresses (category) {
            $('.local_address').hide();
            switch (category) {
        <cms:show offices_selection />


            }
        };




        function toggleMarkers (category) {
            hideAllMarkers();
            closeInfoBox();
            showAddresses( category );

            if ('undefined' === typeof markers[category])
                return false;

            var coordinates = []; // for centering and fitting
            var bound = new google.maps.LatLngBounds();  // for centering and fitting

            markers[category].forEach(function (marker) {
                marker.setMap(mapObject);
                marker.setAnimation(google.maps.Animation.DROP);
                coordinates.push([marker.position.lat(), marker.position.lng()]);
            });

            for (i = 0; i < coordinates.length; i++) {
                bound.extend( new google.maps.LatLng(coordinates[i][0], coordinates[i][1]) );
            }

            mapObject.fitBounds(bound); // Needs to adjust zoom if a single marker to avoid super-zoomed-in zoom(22). Should be okay with 12-15.
            mapObject.panBy(0,0);       // Fix for Maps API, that prevents markers from showing after animation (happens, when next marker to go to is very close)

            if (coordinates.length === 1 ) {
                mapObject.setZoom(7);
            }

        };

        function closeInfoBox() {
            $('div.infoBox').remove();
        };

        function getInfoBox(item) {
            var tel = '';
            for(i = 0; i < item.phone.length; i++){
                tel += '<a href="tel://'+ item.phone[i] +'" class="btn_infobox_phone">'+ item.phone[i] +'</a>';
            }
            return new InfoBox({
                content:
                '<div class="marker_info" id="marker_info">' +
                '<img src="' + item.map_image_url + '" alt="Image" class="hidden-xs"/>' +
                '<h3>'+ item.name_point +'</h3>' +
                '<span>'+ item.description_point +'</span>' +
                '<div class="marker_tools">' +
                '<form action="http://maps.google.com/maps" method="get" target="_blank" style="display:inline-block""><input name="saddr" value="'+ item.get_directions_start_address +'" type="hidden"><input type="hidden" name="daddr" value="'+ item.location_latitude +',' +item.location_longitude
                +'"><button type="submit" value="Get directions" class="btn_infobox_get_directions">Directions</button></form>' +
                    tel +
                    // '<a href="tel://'+ item.phone +'" class="btn_infobox_phone">'+ item.phone +'</a>' +
                    '</div>' +
                    // '<a href="'+ item.url_point + '" class="btn_infobox">Details</a>' +
                    '<a href="javascript:closeInfoBox()" class="btn_infobox visible-xs visible-sm">Close</a>' +
                '</div>',
                disableAutoPan: false,
                maxWidth: 0,
                pixelOffset: new google.maps.Size(10, 125),
                closeBoxMargin: '0px -27px 2px 2px',
                closeBoxURL: "http://www.google.com/intl/en_us/mapfiles/close.gif",
                isHidden: false,
                alignBottom: true,
                pane: 'floatPane',
                enableEventPropagation: true
            });
        };

        <cms:ignore>
        /**
         * Get a center latitude,longitude from an array of like geopoints
         *
         * @param array data 2 dimensional array of latitudes and longitudes
         * For Example:
         * $data = array
         * (
         *   0 = > array(45.849382, 76.322333),
         *   1 = > array(45.843543, 75.324143),
         *   2 = > array(45.765744, 76.543223),
         *   3 = > array(45.784234, 74.542335)
         * );
        */
        </cms:ignore>

        function GetCenterFromDegrees(data)
        {
            if (!(data.length > 0)){
                return false;
            }

            var num_coords = data.length;

            var X = 0.0;
            var Y = 0.0;
            var Z = 0.0;

            for(i = 0; i < data.length; i++){
                var lat = data[i][0] * Math.PI / 180;
                var lon = data[i][1] * Math.PI / 180;

                var a = Math.cos(lat) * Math.cos(lon);
                var b = Math.cos(lat) * Math.sin(lon);
                var c = Math.sin(lat);

                X += a;
                Y += b;
                Z += c;
            }

            X /= num_coords;
            Y /= num_coords;
            Z /= num_coords;

            var lon = Math.atan2(Y, X);
            var hyp = Math.sqrt(X * X + Y * Y);
            var lat = Math.atan2(Z, hyp);

            var newX = (lat * 180 / Math.PI);
            var newY = (lon * 180 / Math.PI);

            return new Array(newX, newY);
        }

